%define ver      0.1.7
%define rel      1
%define prefix   /usr

Summary: Mail Retrieval Proxy
Name: perdition
Version: %ver
Release: %rel
Copyright: GPL
Group: Applications/Internet
Source: ftp://ftp.vergenet.net/pub/perdition/perdition-%{ver}.tar.gz
BuildRoot: /var/tmp/perdition-%{PACKAGE_VERSION}-root
Packager: Horms <horms@vergenet.net>
URL: http://vergenet.net/linux/perdition/
Docdir: %{prefix}/doc
Provides: perdition-%{ver}-%{rel}
Requires: perdition-gdbm-%{ver}-%{rel}
BuildRequires: vanessa_logger-devel vanessa_adt-devel vanessa_socket-devel gdbm-devel MySQL-devel MySQL-shared postgresql-devel openldap-devel popt pam zlib-devel

%description
Perdition is allows users to connect to a content-free POP3 or IMAP4 server
that will redirect them to their real POP3 or IMAP4 server. This enables
mail retrieval for a domain to be split across multiple backend servers on
a per user basis. This can also be used to as a POP3 or IMAP4 proxy
especially in firewall applications. Perdition supports arbitrary library
based map access to determine the server for a user. POSIX Regular
Expression, GDBM, MySQL, PostgreSQL and LDAP libraries ship with the
distribution. 

%package devel
Summary: Headers and static libraries for perditiondb library development
Group: Development/Libraries
Requires: perdition-%{ver}-%{rel}

%description devel
Perdition allows for arbitrary user database access through
shared libraries much in the maner of NSS in glibc. This package
provides headers and libraries that may be useful in the development
of perditiondb libraries.


%package gdbm
Summary: Library to allow perdition to access GDBM based pop maps.
Group: Applications/Internet
Copyright: GPL
Requires: perdition-%{ver}-%{rel}
Provides: perdition-gdbm-%{ver}-%{rel}

%description gdbm
Perdition allows for arbitrary user database access through shared
libraries much in the maner of NSS in glibc. This package allows a user
database stored in a GDBM databse.



%package ldap
Summary: Library to allow perdition to access LDAP based pop maps.
Group: Applications/Internet
Copyright: GPL
Requires: perdition-%{ver}-%{rel}
Provides: perdition-ldap-%{ver}-%{rel}

%description ldap
Perdition allows for arbitrary user database access through shared
libraries much in the maner of NSS in glibc. This package allows a user
database to be sourced from LDAP.


%package mysql
Summary: Library to allow perdition to access MySQL based pop maps.
Group: Applications/Internet
Copyright: GPL
Requires: perdition-%{ver}-%{rel} MySQL-shared zlib
Provides: perdition-mysql-%{ver}-%{rel}

%description mysql
Perdition allows for arbitrary user database access through shared
libraries much in the maner of NSS in glibc. This package allows a user
database stored in a MySQL databse.


%package nis
Summary: Library to allow perdition to access NIS based pop maps.
Group: Applications/Internet
Copyright: GPL
Requires: perdition-%{ver}-%{rel}
Provides: perdition-ldap-%{ver}-%{rel}

%description nis
Perdition allows for arbitrary user database access through shared
libraries much in the maner of NSS in glibc. This package allows a user
database to be sourced from NIS.

It is suggested that you use one of the other database modules instead of
NIS unless you already have a NIS infrastructure.



%package postgresql
Summary: Library to allow perdition to access PosgreSQL based pop maps.
Group: Applications/Internet
Copyright: GPL
Requires: perdition-%{ver}-%{rel}
Provides: perdition-postgresql-%{ver}-%{rel}

%description postgresql
Perdition allows for arbitrary user database access through shared
libraries much in the maner of NSS in glibc. This package allows a user
database stored in a PostgreSQL databse.


%package posix_regex
Summary: Library to allow perdition to access Posig Regular Expression based pop maps.
Group: Applications/Internet
Copyright: GPL
Requires: perdition-%{ver}-%{rel}
Provides: perdition-posix_regex-%{ver}-%{rel}

%description posix_regex
Perdition allows for arbitrary user database access through shared
libraries much in the maner of NSS in glibc. This package allows a user
database to be expreses as a series of Posix Regular Expressions.





%prep
%setup

%build
CFLAGS="${RPM_OPT_FLAGS}" ./configure --prefix=%prefix --sysconfdir=/etc
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}/etc/{rc.d/init.d,sysconfig}

make DESTDIR=$RPM_BUILD_ROOT install-strip

install -m755 \
  ${RPM_BUILD_DIR}/perdition-%{ver}/etc/rc.d/init.d/perdition.rh \
  ${RPM_BUILD_ROOT}/etc/rc.d/init.d/perdition
install -m644 ${RPM_BUILD_DIR}/perdition-%{ver}/etc/sysconfig/perdition \
  ${RPM_BUILD_ROOT}/etc/sysconfig/perdition
  

%clean
rm -rf $RPM_BUILD_DIR/perdition-%{ver}
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add perdition

%post gdbm
make -q -C /etc/perdition/
true

%postun

%preun
/sbin/chkconfig --del perdition

%preun gdbm
make -q -C /etc/perdition/ clean
true


%files
%defattr(-,root,root)
%doc %attr(-, root, root) README
%doc %attr(-, root, root) ChangeLog NEWS CODING_LOCATIONS TODO
%{prefix}/sbin/perdition
%{prefix}/sbin/perdition.pop3
%{prefix}/sbin/perdition.imap4
%{prefix}/lib/libjain.so
%{prefix}/lib/libjain.so.0
%{prefix}/lib/libjain.so.0.0.0
/etc/pam.d/perdition
/etc/rc.d/init.d/perdition
%config /etc/sysconfig/perdition
%config /etc/perdition/perdition.conf
%{prefix}/man/man8/perdition.*
%{prefix}/man/man5/perditiondb.*

%files devel
%defattr(-,root,root)
%{prefix}/include/jain.h
%{prefix}/lib/libjain.a
%{prefix}/lib/libjain.la

%files gdbm
%defattr(-,root,root)
%{prefix}/lib/libperditiondb_gdbm.a
%{prefix}/lib/libperditiondb_gdbm.la
%{prefix}/lib/libperditiondb_gdbm.so
%{prefix}/lib/libperditiondb_gdbm.so.0
%{prefix}/lib/libperditiondb_gdbm.so.0.0.0
%{prefix}/bin/makegdbm
/etc/perdition/Makefile
/etc/perdition/Makefile.popmap
%{prefix}/man/man1/makegdbm.*
%config /etc/perdition/popmap

%files ldap
%defattr(-,root,root)
%{prefix}/lib/libperditiondb_ldap.a
%{prefix}/lib/libperditiondb_ldap.la
%{prefix}/lib/libperditiondb_ldap.so
%{prefix}/lib/libperditiondb_ldap.so.0
%{prefix}/lib/libperditiondb_ldap.so.0.0.0
%{prefix}/bin/perditiondb_ldap_makedb
%{prefix}/man/man8/perditiondb_ldap_makedb.*

%files mysql
%defattr(-,root,root)
%{prefix}/lib/libperditiondb_mysql.a
%{prefix}/lib/libperditiondb_mysql.la
%{prefix}/lib/libperditiondb_mysql.so
%{prefix}/lib/libperditiondb_mysql.so.0
%{prefix}/lib/libperditiondb_mysql.so.0.0.0
%{prefix}/bin/perditiondb_mysql_makedb
%{prefix}/man/man8/perditiondb_mysql_makedb.*

%files nis
%defattr(-,root,root)
%{prefix}/lib/libperditiondb_nis.a
%{prefix}/lib/libperditiondb_nis.la
%{prefix}/lib/libperditiondb_nis.so
%{prefix}/lib/libperditiondb_nis.so.0
%{prefix}/lib/libperditiondb_nis.so.0.0.0

%files posix_regex
%defattr(-,root,root)
%{prefix}/lib/libperditiondb_posix_regex.a
%{prefix}/lib/libperditiondb_posix_regex.la
%{prefix}/lib/libperditiondb_posix_regex.so
%{prefix}/lib/libperditiondb_posix_regex.so.0
%{prefix}/lib/libperditiondb_posix_regex.so.0.0.0
%config /etc/perdition/popmap.re

%files postgresql
%defattr(-,root,root)
%{prefix}/lib/libperditiondb_postgresql.a
%{prefix}/lib/libperditiondb_postgresql.la
%{prefix}/lib/libperditiondb_postgresql.so
%{prefix}/lib/libperditiondb_postgresql.so.0
%{prefix}/lib/libperditiondb_postgresql.so.0.0.0
%{prefix}/bin/perditiondb_postgresql_makedb
%{prefix}/man/man8/perditiondb_postgresql_makedb.*


%changelog
* Mon Nov 27 2000 Horms <horms@vergenet.net>
- Modified to reflect build process handling instalation of config files
- Split GDBM and Posix_Regex into separate packages

* Mon Oct 16 2000 Horms <horms@vergenet.net>
- added NIS library

* Mon May 15 2000 Horms <horms@vergenet.net>
- added sysconfig file
- split libraries into separate packages so that packages such
  as postgress and mysql don't have to be installed for perdition
  to install cleanly.
- added sample ldap server configuration

* Thu May  4 2000 Horms <horms@vergenet.net>
- added perditiondb_ldap files
- added missing perditiondb_postgresql devel files

* Thu Apr 20 2000 Horms <horms@vergenet.net>
- added perditiondb_postgresql files

* Tue Jan  4 2000 Horms <horms@vergenet.net>
- added libraries
- added headers
- made devel package
- made libtcp_socket and libtcp_socket-devel package
- Included mysql and posix_regex stuff in /etc

* Mon Nov 29 1999 Horms <horms@vergenet.net>
- Added perdition.conf

* Sat Sep 18 1999 Horms <horms@vergenet.net>
- updated for 0.1.0

* Sat May 29 1999 Horms <horms@vergenet.net>
- inital release
